#pragma once

#include "const.h"
#include "IModule.h"
#include "IInstallController.h"

/**
* @class IPrepareModuleCallback
* PrepareModule   Callback ϱ  Interafce 
* ο ȴ.
*
* @author : DaeMyung.Kang
*/
class IPrepareModuleCallback : public ICallback
{
public:
	virtual ~IPrepareModuleCallback()
	{

	}

	virtual CALLBACK_RETURN OnStart()
	{
		return CALLBACK_RETURN_CONTINUE;
	}

	/** 
	* @fn CALLBACK_RETURN OnProgress( CALLBACK_PROGRESS_SIZE currentSize,
	*								  CALLBACK_PROGRESS_SIZE maxSize,
	*								  CALLBACK_PROGRESS_STATUS status )
	* @brief  ٿε ÿ    ˷ִ Լ̴.
	* @param
	*			currentSize :  ٿε  
	*			maxSize		:  ִ 
	*			status		: , PENDING  ˷ش.
	* @return 
	*			CALLBACK_RETURN_CANCEL		:  ۾ Ѵ.
	*			CALLBACK_RETURN_CONTINUE	:  ۾ Ѵ.
	*/
	virtual CALLBACK_RETURN OnProgress(	CALLBACK_PROGRESS_SIZE currentSize,
		CALLBACK_PROGRESS_SIZE maxSize,
		CALLBACK_PROGRESS_STATUS status )
	{
		return CALLBACK_RETURN_CONTINUE;
	}

	/** 
	* @fn CALLBACK_RETURN OnFinished( CALLBACK_FINISHED_STATUS status )
	* @brief Prepare ۾   ˷ִ Լ̴.
	* @param
	*			status		:  ¸ ˷ش.(  , ,  )
	* @return 
	*			CALLBACK_RETURN_CANCEL		: Install ۾  ʴ´.
	*			CALLBACK_RETURN_CONTINUE	: Install ۾ Ѵ.
	*/
	virtual CALLBACK_RETURN OnFinished( CALLBACK_FINISHED_STATUS status, ERRORINFO *info ) = 0;
};

class IInstallModule;
class IPrepareModule : public IModule
{
public:
	IPrepareModule(const TCHAR *guid);
	virtual ~IPrepareModule();

	virtual BOOL Prepare() = 0;
	BOOL Prepare(IPrepareModuleCallback* callback);
	IPrepareModuleCallback *GetCallback();
	virtual IInstallModule *GetInstallComponent() = 0;
};
